'  ------------------------------------------------------------------------------------
'  irr::core::array<S3DVertex2TCoords> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_S3DVertex2TCoords_linear_reverse_search:Int(parray_S3DVertex2TCoords_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_linear_search:Int(parray_S3DVertex2TCoords_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_binary_search:Int(parray_S3DVertex2TCoords_arr:Int,find:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_binary_searchWithBounds:Int(parray_S3DVertex2TCoords_arr:Int,find:Int,nLeft:Int,nRight:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_sort(parray_S3DVertex2TCoords_arr:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_const_pointer:Int(parray_S3DVertex2TCoords_arr:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_pointer:Int(parray_S3DVertex2TCoords_arr:Int)
	'Function IrrCore_Array_S3DVertex2TCoords_set_pointer(parray_S3DVertex2TCoords_arr:Int,newPointer:Int,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_S3DVertex2TCoords Extends IrrBase Final

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_S3DVertex2TCoords(start_count:Int)
		Return createFromHandle(IrrCore_Array_S3DVertex2TCoords_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_S3DVertex2TCoords(other:Array_S3DVertex2TCoords)
		Return createFromHandle(IrrCore_Array_S3DVertex2TCoords_newFromOther(other.handle))
	EndFunction

	Function create:Array_S3DVertex2TCoords()
		Return createFromHandle(IrrCore_Array_S3DVertex2TCoords_new())
	EndFunction
	
	Function createFromHandle:Array_S3DVertex2TCoords(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_S3DVertex2TCoords=New Array_S3DVertex2TCoords
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_S3DVertex2TCoords_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------
	
	Method allocated_size:Int()
		Return IrrCore_Array_S3DVertex2TCoords_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_S3DVertex2TCoords_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_S3DVertex2TCoords_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_S3DVertex2TCoords_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_S3DVertex2TCoords_erase(handle,idx)
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_S3DVertex2TCoords_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_S3DVertex2TCoords_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_S3DVertex2TCoords_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_S3DVertex2TCoords_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_S3DVertex2TCoords_size(handle)
	EndMethod

	Method getLast:S3DVertex2TCoords()
		'  do Not Delete this pointer
		Return S3DVertex2TCoords.createFromHandle(IrrCore_Array_S3DVertex2TCoords_getLast(handle),False)
	EndMethod

	Method elementAt:S3DVertex2TCoords(idx:Int)
		'  do Not Delete this pointer
		Return S3DVertex2TCoords.createFromHandle(IrrCore_Array_S3DVertex2TCoords_elementAt(handle,idx),False)
	EndMethod
	
	Method insert(element:S3DVertex2TCoords,idx:Int=0)
		IrrCore_Array_S3DVertex2TCoords_insert(handle,element.handle,idx)
	EndMethod

	Method Eq(other:Array_S3DVertex2TCoords)
		IrrCore_Array_S3DVertex2TCoords_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:S3DVertex2TCoords)
		IrrCore_Array_S3DVertex2TCoords_push_back(handle,element.handle)
	EndMethod
	
	Method push_front(element:S3DVertex2TCoords)
		IrrCore_Array_S3DVertex2TCoords_push_front(handle,element.handle)
	EndMethod
		
EndType




