Public
' ------------------------------------------------------------------------------------
'  irr::gui::IGUIListBox wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Type IGUIListBox Extends IGUIElement Final

	Function createFromHandle:IGUIListBox(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIListBox=New IGUIListBox
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction	
	
	Method addItem:Int(text:String)
		IrrGUI_IGUIListBox_addItem(handle,StringToWChar(text))
	EndMethod
	
	Method addItemWithIcon:Int(text:String,icon:Int)
		Return IrrGUI_IGUIListBox_addItemWithIcon(handle,StringToWChar(text),icon)
	EndMethod
	
	Method clear()
		IrrGUI_IGUIListBox_clear(handle)
	EndMethod
	
	Method getItemCount:Int()
		Return IrrGUI_IGUIListBox_getItemCount(handle)
	EndMethod
	
	Method getListItem:String(idx:Int)
		Return WCharToString(IrrGUI_IGUIListBox_getListItem(handle,idx))
	EndMethod
	
	Method getSelected:Int()
		Return IrrGUI_IGUIListBox_getSelected(handle)
	EndMethod
		
	Method setSelected(idx:Int)
		IrrGUI_IGUIListBox_setSelected(handle,idx)
	EndMethod

	Method setSelectedByText(text:String)
		IrrGUI_IGUIListBox_setSelectedByText(handle, text)
	EndMethod

	Method removeItem(index:Int)
		IrrGUI_IGUIListBox_removeItem(handle,index)
	EndMethod
	
	Method setSpriteBank(bank:IGUISpriteBank)
		IrrGUI_IGUIListBox_setSpriteBank(handle,bank.handle)
	EndMethod

	Method getIcon:Int(id:Int)
		Return IrrGUI_IGUIListBox_getIcon(handle,id)
	EndMethod

	Method setAutoScrollEnabled(bScroll:Int)
		IrrGUI_IGUIListBox_setAutoScrollEnabled(handle,bScroll)
	EndMethod
	
	Method isAutoScrollEnabled:Int()
		Return IrrGUI_IGUIListBox_isAutoScrollEnabled(handle)
	EndMethod
	
	Method setItemOverrideColor(index:Int, color:SColor)
		IrrGUI_IGUIListBox_setItemOverrideColor(handle,index,color.handle)
	EndMethod
	
	Method setItemOverrideColorByType(index:Int, EGUI_LISTBOX_COLOR:Int, color:SColor)
		IrrGUI_IGUIListBox_setItemOverrideColorByType(handle,index,EGUI_LISTBOX_COLOR,color.handle)
	EndMethod
	
	Method clearItemOverrideColor(index:Int)
		IrrGUI_IGUIListBox_clearItemOverrideColor(handle,index)
	EndMethod
	
	Method clearItemOverrideColorByType(index:Int, EGUI_LISTBOX_COLOR:Int)
		IrrGUI_IGUIListBox_clearItemOverrideColorByType(handle, index, EGUI_LISTBOX_COLOR)
	EndMethod
	
	Method hasItemOverrideColor:Int(index:Int, EGUI_LISTBOX_COLOR:Int)
		Return IrrGUI_IGUIListBox_hasItemOverrideColor(handle,index, EGUI_LISTBOX_COLOR)
	EndMethod
	
	Method getItemOverrideColor:SColor(index:Int, EGUI_LISTBOX_COLOR:Int)
		Return SColor.createFromHandle(IrrGUI_IGUIListBox_getItemOverrideColor:Int(handle, index, EGUI_LISTBOX_COLOR), True)
	EndMethod
	
	Method getItemDefaultColor:SColor(EGUI_LISTBOX_COLOR:Int)
		Return SColor.createFromHandle(IrrGUI_IGUIListBox_getItemDefaultColor(handle,EGUI_LISTBOX_COLOR), True)
	EndMethod
	
	Method setItem(index:Int, text:String, icon:Int)
		IrrGUI_IGUIListBox_setItem(handle,index, StringToWChar(text), icon)
	EndMethod
	
	Method insertItem:Int(index:Int, text:String, icon:Int)
		Return IrrGUI_IGUIListBox_insertItem(handle,index, StringToWChar(text), icon)
	EndMethod
	
	Method swapItems(index1:Int, index2:Int)
		IrrGUI_IGUIListBox_swapItems(handle, index1, index2)
	EndMethod

	Method setItemHeight(height:Int)
		IrrGUI_IGUIListBox_setItemHeight(handle, height)
	EndMethod
	
	Method setDrawBackground(bDraw:Int)
		IrrGUI_IGUIListBox_setDrawBackground(handle, bDraw) 
	EndMethod

EndType
    


