' ------------------------------------------------------------------------------------
'  irr::scene::IBillboardTextSceneNode wrappers (parent is IBillboardSceneNode)
' ------------------------------------------------------------------------------------
Public

Type IBillboardTextSceneNode Extends IBillboardSceneNode Final

	Function createFromHandle:IBillboardTextSceneNode(pHandle:Int,bMustDel:Int=True,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IBillboardTextSceneNode=New IBillboardTextSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
	Method getSize:Dimension2df()
		Return Dimension2df.createFromHandle(IrrScene_IBillboardTextSceneNode_getSize(handle))
	EndMethod
	
	Method setSize(size:Dimension2df)
		IrrScene_IBillboardTextSceneNode_setSize(handle,size.handle)
	EndMethod

	Method setColor(overallColor:SColor)
		IrrScene_IBillboardTextSceneNode_setColor(handle,overallColor.handle)
	EndMethod
	
	Method setColorTopBottom(topColor:SColor,bottomColor:SColor)
		IrrScene_IBillboardTextSceneNode_setColorTopBottom(handle,topColor.handle,bottomColor.handle)
	EndMethod
	
	Method getColor(topColor:SColor,bottomColor:SColor)
		IrrScene_IBillboardTextSceneNode_getColor(handle,topColor.handle,bottomColor.handle)
	EndMethod

	Method setText(text:String)
		IrrScene_IBillboardTextSceneNode_setText(handle, StringToWChar(text))
	EndMethod
	
	Method setTextColor(color:SColor)
		IrrScene_IBillboardTextSceneNode_setTextColor(handle, _HANDLE(color))
	EndMethod

EndType

