' ------------------------------------------------------------------------------------
'  irr::scene::IMeshCache wrappers
' ------------------------------------------------------------------------------------
Public

Type IMeshCache Extends IReferenceCounted

	Function createFromHandle:IMeshCache(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMeshCache=New IMeshCache
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addMesh(name:String, mesh:IAnimatedMesh)
		IrrScene_IMeshCache_addMesh(handle,name,mesh.handle)
	EndMethod
	
	Method removeAnimatedMesh(mesh:IAnimatedMesh)
		IrrScene_IMeshCache_removeAnimatedMesh(handle,mesh.handle)
	EndMethod

	Method removeMesh(mesh:IMesh)
		IrrScene_IMeshCache_removeMesh(handle,mesh.handle)
	EndMethod
	
	Method getMeshCount:Int()
		Return IrrScene_IMeshCache_getMeshCount(handle)
	EndMethod
	
	Method getAnimatedMeshIndex:Int(mesh:IAnimatedMesh)
		Return IrrScene_IMeshCache_getAnimatedMeshIndex:Int(handle,mesh.handle)
	EndMethod

	Method getMeshIndex:Int(mesh:IMesh)
		Return IrrScene_IMeshCache_getMeshIndex:Int(handle,mesh.handle)
	EndMethod
	
	' do not delete
	Method getMeshByIndex:IAnimatedMesh(index:Int)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshCache_getMeshByIndex(handle,index),False)
	EndMethod

	Method getMeshNameByIdx:String(index:Int)
		Return String.FromCString(IrrScene_IMeshCache_getMeshNameByIdx(handle,index))
	EndMethod
	
	Method getAnimatedMeshName:String(mesh:IAnimatedMesh)
		Return String.FromCString(IrrScene_IMeshCache_getAnimatedMeshName(handle,mesh.handle))
	EndMethod
	
	Method getMeshName:String(mesh:IMesh)
		Return String.FromCString(IrrScene_IMeshCache_getMeshName(handle,mesh.handle))
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMeshCache_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMeshCache_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMeshCache_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
	
	Method getMeshByName:IAnimatedMesh(name:String)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshCache_getMeshByName(handle,name),False)
	EndMethod

	Method renameMeshByIndex:Int(index:Int,name:String)
		Return IrrScene_IMeshCache_renameMeshByIndex(handle,index,name)
	EndMethod
	
	Method renameAnimatedMesh:Int(mesh:IAnimatedMesh,name:String)
		Return IrrScene_IMeshCache_renameAnimatedMesh(handle,mesh.handle,name)
	EndMethod
	
	Method renameMesh:Int(mesh:IMesh,name:String)
		Return IrrScene_IMeshCache_renameMesh(handle,mesh.handle,name)
	EndMethod

	Method isMeshLoaded:Int(name:String)
		Return IrrScene_IMeshCache_isMeshLoaded(handle,name)	
	EndMethod
	
	Method clear()
		IrrScene_IMeshCache_clear(handle)
	EndMethod
	
	Method clearUnusedMeshes()
		IrrScene_IMeshCache_clearUnusedMeshes(handle)
	EndMethod

EndType


