' ------------------------------------------------------------------------------------
'  irr::scene::ITerrainSceneNode wrappers (based on ISceneNode)
' ------------------------------------------------------------------------------------
Public

Type ITerrainSceneNode Extends ISceneNodeDefault Final

	Function createFromHandle:ITerrainSceneNode(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:ITerrainSceneNode=New ITerrainSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getBoundingBoxFromPatch:AABbox3df(patchX:Int,patchZ:Int)
		Return AABbox3df.createFromHandle(IrrScene_ITerrainSceneNode_getBoundingBoxFromPatch(handle,patchX,patchZ))
	EndMethod
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_ITerrainSceneNode_getBoundingBox(handle))
	EndMethod
	
	Method getCurrentLODOfPatches:Int(LODs:Array_s32)
		Return IrrScene_ITerrainSceneNode_getCurrentLODOfPatches(handle,LODs.handle)
	EndMethod
	
	Method getIndexCount:Int()
		Return IrrScene_ITerrainSceneNode_getIndexCount(handle)
	EndMethod
	
	Method getIndicesForPatch:Int(outIndices:Array_u32,patchX:Int,patchZ:Int,LOD:Int=0)
		'  note, this populates outIndicies
		Return IrrScene_ITerrainSceneNode_getIndicesForPatch(handle,outIndices.handle,patchX,patchZ,LOD)
	EndMethod

	Method getMesh:IMesh()
		' do not delete
		Return IMesh.createFromHandle(IrrScene_ITerrainSceneNode_getMesh(handle),False)
	EndMethod
	
	Method getMeshBufferForLOD(mb:IDynamicMeshBuffer, LOD:Int = 0)
		IrrScene_ITerrainSceneNode_getMeshBufferForLOD(handle,mb.handle,LOD)
	EndMethod
	
	Method setLODOfPatch(patchX:Int,patchZ:Int,LOD:Int = 0)
		IrrScene_ITerrainSceneNode_setLODOfPatch(handle,patchX,patchZ,LOD)
	EndMethod

	Method getTerrainCenter:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ITerrainSceneNode_getTerrainCenter(handle))
	EndMethod
	
	Method overrideLODDistance:Int(LOD:Int,newDistance:Double)
		Return IrrScene_ITerrainSceneNode_overrideLODDistance(handle,LOD,newDistance)
	EndMethod
	
	Method scaleTexture(scale:Float=1.0,scale2:Float=0.0)
		IrrScene_ITerrainSceneNode_scaleTexture(handle,scale,scale2)
	EndMethod
	
	Method setCameraMovementDelta(delta:Float)
		IrrScene_ITerrainSceneNode_setCameraMovementDelta(handle,delta)
	EndMethod
	
	Method setCameraRotationDelta(delta:Float)
		IrrScene_ITerrainSceneNode_setCameraRotationDelta(handle,delta)
	EndMethod
	
	Method setDynamicSelectorUpdate(bVal:Int)
		IrrScene_ITerrainSceneNode_setDynamicSelectorUpdate(handle,bVal)
	EndMethod

	Method getHeight:Float(x:Float,y:Float)
		Return IrrScene_ITerrainSceneNode_getHeight(handle,x,y)
	EndMethod

	Method loadHeightMap:Int(file:IReadFile, vertexColor:SColor = Null, smoothFactor:Int = 0)
		Return IrrScene_ITerrainSceneNode_loadHeightMap(handle, file.handle, _HANDLE(vertexColor), smoothFactor)
	EndMethod
	
	Method loadHeightMapRAW:Int(file:IReadFile, bitsPerPixel:Int = 16, bSignedData:Int = False, bFloatVals:Int = False, width:Int = 0, vertexColor:SColor = Null, smoothFactor:Int = 0)
		Return IrrScene_ITerrainSceneNode_loadHeightMapRAW(handle, file.handle, bitsPerPixel, bSignedData, bFloatVals, width, _HANDLE(vertexColor), smoothFactor)
	EndMethod

EndType

