' ------------------------------------------------------------------------------------
'  irr::scene::SMesh wrappers (parent is IMesh)
' ------------------------------------------------------------------------------------
Public

Type SMesh Extends IMesh Final

	Function createFromHandle:SMesh(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SMesh=New SMesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Function create:SMesh()
		Return createFromHandle(IrrScene_SMesh_new())
	EndFunction
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_SMesh_getBoundingBox(handle),True)
	EndMethod
	
	Method addMeshBuffer(buf:IMeshBuffer)
		IrrScene_SMesh_addMeshBuffer(handle,buf.handle)
	EndMethod
	
	Method getMeshBuffer:IMeshBuffer(idx:Int)
		'  do note Delete this pointer
		Return IMeshBuffer.createFromHandle(IrrScene_SMesh_getMeshBuffer(handle,idx),False)
	EndMethod
	
	Method getMeshBufferCount:Int()
		Return IrrScene_SMesh_getMeshBufferCount(handle)
	EndMethod
	
	Method recalculateBoundingBox()
		IrrScene_SMesh_recalculateBoundingBox(handle)
	EndMethod
	
	Method setMaterialFlag(E_MATERIAL_FLAG_flag:Int,bNewvalue:Int)
		IrrScene_SMesh_setMaterialFlag(handle,E_MATERIAL_FLAG_flag,bNewvalue)
	EndMethod

	Method setBoundingBox(box:AABbox3df)
		IrrScene_SMesh_setBoundingBox(handle,box.handle)
	EndMethod
	
	Method getMeshBufferFromMaterial:IMeshBuffer(mat:SMaterial)
		Return IMeshBuffer.createFromHandle(IrrScene_SMesh_getMeshBufferFromMaterial(handle,mat.handle),False)
	EndMethod
	
EndType




