' ------------------------------------------------------------------------------------
'  irr::scene::SSkinMeshBuffer wrappers
' ------------------------------------------------------------------------------------
Public

Type SSkinMeshBuffer Extends IMeshBuffer

	Function create:SSkinMeshBuffer(E_VERTEX_TYPE:Int = EVT_STANDARD)
		Return createFromHandle(IrrScene_SSkinMeshBuffer_new(E_VERTEX_TYPE),True)
	EndFunction

	Function createFromHandle:SSkinMeshBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SSkinMeshBuffer=New SSkinMeshBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method convertTo2TCoords()
		IrrScene_SSkinMeshBuffer_convertTo2TCoords(handle)
	EndMethod
	
	Method convertToTangents()
		IrrScene_SSkinMeshBuffer_convertToTangents(handle)
	EndMethod
	
	Method boundingBoxNeedsRecalculated()
		IrrScene_SSkinMeshBuffer_boundingBoxNeedsRecalculated(handle)
	EndMethod

	Method append(vertices:S3DVertex[], indices:Short[])
		Local vertices_size:Int = 0
		Local indices_size:Int = 0
		Local vertices_array:Int[]=GetHandleArray(vertices)
		If vertices_array Then vertices_size=vertices_array.Dimensions()[0]
		If indices Then indices_size = indices.Dimensions()[0]
		
		IrrScene_SSkinMeshBuffer_append(handle, vertices_array,vertices_size, indices, indices_size)
	EndMethod

EndType


