' ------------------------------------------------------------------------------------
'  irr::video::IGPUProgrammingServices wrappers
' 
'  WARNING: this cannot be created manually.  it can be obtained by calling
'  IVideoDriver::getGPUProgrammingServices()
' ------------------------------------------------------------------------------------
Public

Type IGPUProgrammingServices Extends IrrBase Final

	Function createFromHandle:IGPUProgrammingServices(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IGPUProgrammingServices=New IGPUProgrammingServices
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addHighLevelShaderMaterial:Int( ..
		vertexShaderProgram:String, ..
		vertexShaderEntryPointName:String, ..
		E_VERTEX_SHADER_TYPE_vsCompileTarget:Int, ..
		pixelShaderProgram:String, ..
		pixelShaderEntryPointName:String, ..
		E_PIXEL_SHADER_TYPE_psCompileTarget:Int, ..
		geometryShaderProgram:String, ..
		geometryShaderEntryPointName:String = "main", ..
		E_GEOMETRY_SHADER_TYPE_gsCompileTarget:Int = EGST_GS_4_0, ..
		E_PRIMITIVE_TYPE_inType:Int = EPT_TRIANGLES, ..
		E_PRIMITIVE_TYPE_outType:Int = EPT_TRIANGLE_STRIP, ..
		verticesOut:Int = 0, ..			
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)
		
		Return IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterial( ..
			handle, ..
			vertexShaderProgram, ..
			vertexShaderEntryPointName, ..
			E_VERTEX_SHADER_TYPE_vsCompileTarget, ..
			pixelShaderProgram, ..
			pixelShaderEntryPointName, ..
			E_PIXEL_SHADER_TYPE_psCompileTarget, ..
			geometryShaderProgram, ..
			geometryShaderEntryPointName, ..
			E_GEOMETRY_SHADER_TYPE_gsCompileTarget, ..
			E_PRIMITIVE_TYPE_inType, ..
			E_PRIMITIVE_TYPE_outType, ..
			verticesOut, ..			
			_HANDLE(callback), ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod
	
	Method addHighLevelShaderMaterialFromFiles:Int( ..
		vertexShaderProgramFileName:String, ..
		vertexShaderEntryPointName:String, ..
		E_VERTEX_SHADER_TYPE_vsCompileTarget:Int, ..
		pixelShaderProgramFileName:String, ..
		pixelShaderEntryPointName:String, ..
		E_PIXEL_SHADER_TYPE_psCompileTarget:Int, ..
		geometryShaderProgramFileName:String, ..
		geometryShaderEntryPointName:String = "main", ..
		E_GEOMETRY_SHADER_TYPE_gsCompileTarget:Int = EGST_GS_4_0, ..
		E_PRIMITIVE_TYPE_inType:Int = EPT_TRIANGLES, ..
		E_PRIMITIVE_TYPE_outType:Int = EPT_TRIANGLE_STRIP, ..
		verticesOut:Int = 0, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		Return IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFiles( ..
			handle, ..
			vertexShaderProgramFileName, ..
			vertexShaderEntryPointName, ..
			E_VERTEX_SHADER_TYPE_vsCompileTarget, ..
			pixelShaderProgramFileName, ..
			pixelShaderEntryPointName, ..
			E_PIXEL_SHADER_TYPE_psCompileTarget, ..
			geometryShaderProgramFileName, ..
			geometryShaderEntryPointName, ..
			E_GEOMETRY_SHADER_TYPE_gsCompileTarget, ..
			E_PRIMITIVE_TYPE_inType, ..
			E_PRIMITIVE_TYPE_outType, ..
			verticesOut, ..
			_HANDLE(callback), ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod	

	Method addHighLevelShaderMaterialFromFilesNoGeometryShaders:Int( ..
		vertexShaderProgramFileName:String, ..
		vertexShaderEntryPointName:String = "main", ..
		E_VERTEX_SHADER_TYPE_vsCompileTarget:Int = EVST_VS_1_1, ..
		pixelShaderProgramFileName:String = "", ..
		pixelShaderEntryPointName:String = "main", ..
		E_PIXEL_SHADER_TYPE_psCompileTarget:Int = EPST_PS_1_1, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		Return IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFiles( ..
			handle, ..
			vertexShaderProgramFileName, ..
			vertexShaderEntryPointName, ..
			E_VERTEX_SHADER_TYPE_vsCompileTarget, ..
			pixelShaderProgramFileName, ..
			pixelShaderEntryPointName, ..
			E_PIXEL_SHADER_TYPE_psCompileTarget, ..
			"", ..
			"main", ..
			EGST_GS_4_0, ..
			EPT_TRIANGLES, ..
			EPT_TRIANGLE_STRIP, ..
			Null, ..
			_HANDLE(callback), ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod	

	Method addHighLevelShaderMaterialFromFilesIO:Int( ..
		vertexShaderProgram:IReadFile, ..
		vertexShaderEntryPointName:String, ..
		E_VERTEX_SHADER_TYPE_vsCompileTarget:Int, ..
		pixelShaderProgram:IReadFile, ..
		pixelShaderEntryPointName:String, ..
		E_PIXEL_SHADER_TYPE_psCompileTarget:Int, ..
		geometryShaderProgram:IReadFile, ..
		geometryShaderEntryPointName:String = "main", ..
		E_GEOMETRY_SHADER_TYPE_gsCompileTarget:Int = EGST_GS_4_0, ..
		E_PRIMITIVE_TYPE_inType:Int = EPT_TRIANGLES, ..
		E_PRIMITIVE_TYPE_outType:Int = EPT_TRIANGLE_STRIP, ..
		verticesOut:Int = 0, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		Return IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFilesIO( ..
			handle, ..
			_HANDLE(vertexShaderProgram), ..
			vertexShaderEntryPointName, ..
			E_VERTEX_SHADER_TYPE_vsCompileTarget, ..
			_HANDLE(pixelShaderProgram), ..
			pixelShaderEntryPointName, ..
			E_PIXEL_SHADER_TYPE_psCompileTarget, ..
			_HANDLE(geometryShaderProgram), ..
			geometryShaderEntryPointName, ..
			E_GEOMETRY_SHADER_TYPE_gsCompileTarget, ..
			E_PRIMITIVE_TYPE_inType, ..
			E_PRIMITIVE_TYPE_outType, ..
			verticesOut, ..
			_HANDLE(callback), ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod	
	
	Method addHighLevelShaderMaterialFromFileStream:Int( ..
		vertexShaderProgram:IReadFile, ..
		vertexShaderEntryPointName:String=Null, ..
		E_VERTEX_SHADER_TYPE_vsCompileTarget:Int=EVST_VS_1_1, ..
		pixelShaderProgram:IReadFile=Null, ..
		pixelShaderEntryPointName:String=Null, ..
		E_PIXEL_SHADER_TYPE_psCompileTarget:Int=EPST_PS_1_1, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		Local tempVSEPN:Byte Ptr
		If vertexShaderEntryPointName=Null Then tempVSEPN=Null Else tempVSEPN=vertexShaderEntryPointName.ToCString()
		If pixelShaderProgram=Null Then pixelShaderProgram=New IReadFile 'default handle to 0
		Local tempPSEPN:Byte Ptr
		If pixelShaderEntryPointName=Null Then tempPSEPN=Null Else tempPSEPN=pixelShaderEntryPointName.ToCString()		
		If callback=Null Then callback=New IShaderConstantSetCallBack ' default handle to 0

		Return IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFileStream( ..
			handle, ..
			vertexShaderProgram.handle, ..
			tempVSEPN, ..
			E_VERTEX_SHADER_TYPE_vsCompileTarget, ..
			pixelShaderProgram.handle, ..
			tempPSEPN, ..
			E_PIXEL_SHADER_TYPE_psCompileTarget, ..
			callback.handle, ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod

	Method addShaderMaterial:Int( ..
		vertexShaderProgram:String=Null, ..
		pixelShaderProgram:String=Null, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		If callback=Null Then callback=New IShaderConstantSetCallBack ' default handle to 0

		Return IrrVideo_IGPUProgrammingServices_addShaderMaterial( ..
			handle, ..
			vertexShaderProgram.ToCString(), ..
			pixelShaderProgram.ToCString(), ..
			callback.handle, ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	
	EndMethod

	Method addShaderMaterialFromFiles:Int( ..
		vertexShaderProgramFileName:String, ..
		pixelShaderProgramFileName:String, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		If callback=Null Then callback=New IShaderConstantSetCallBack ' default handle to 0

		Return IrrVideo_IGPUProgrammingServices_addShaderMaterialFromFiles( ..
			handle, ..
			vertexShaderProgramFileName.ToCString(), ..
			pixelShaderProgramFileName.ToCString(), ..
			callback.handle, ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod

	Method addShaderMaterialFromFileStream:Int( ..
		vertexShaderProgram:IReadFile=Null, ..
		pixelShaderProgram:IReadFile=Null, ..
		callback:IShaderConstantSetCallBack=Null, ..
		E_MATERIAL_TYPE_baseMaterial:Int=EMT_SOLID, ..
		userData:Int=0)

		If vertexShaderProgram=Null Then vertexShaderProgram=New IReadFile 'default handle to 0
		If pixelShaderProgram=Null Then pixelShaderProgram=New IReadFile 'default handle to 0
		If callback=Null Then callback=New IShaderConstantSetCallBack ' default handle to 0

		Return IrrVideo_IGPUProgrammingServices_addShaderMaterialFromFileStream( ..
			handle, ..
			vertexShaderProgram.handle, ..
			pixelShaderProgram.handle, ..
			callback.handle, ..
			E_MATERIAL_TYPE_baseMaterial, ..
			userData)
	EndMethod
EndType

