' ------------------------------------------------------------------------------------
' irr::video::ITexture wrappers
'
' you cannot create ITextures directly.  you must use IVideoDriver::addTexture() Or
' IVideoDriver::getTexture().  you do Not Delete these references, you remove them with
' IVideoDriver::removeTexture().
' ------------------------------------------------------------------------------------
Public

Type ITexture Extends IReferenceCounted Final

	Function createFromHandle:ITexture(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ITexture=New ITexture
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	' cast to either Short Ptr or Int Ptr if needed
	Method lock:Byte Ptr(bReadOnly:Int = False, mipmapLevel:Int = 0)
		Return IrrVideo_ITexture_lock(handle, bReadOnly, mipmapLevel)
	EndMethod

	Method unlock()
		IrrVideo_ITexture_unlock(handle)
	EndMethod
	
	Method getOriginalSize:Dimension2di()
		Return Dimension2di.createFromHandle(IrrVideo_ITexture_getOriginalSize(handle)) 
	EndMethod
	
	Method getSize:Dimension2di()
		Return Dimension2di.createFromHandle(IrrVideo_ITexture_getSize(handle))
	EndMethod
	
	' returns E_DRIVER_TYPE
	Method getDriverType:Int()
		Return IrrVideo_ITexture_getDriverType(handle)
	EndMethod
	
	' returns ECOLOR_FORMAT
	Method getColorFormat:Int()
		Return IrrVideo_ITexture_getColorFormat(handle)  
	EndMethod
	
	Method getPitch:Int()
		Return IrrVideo_ITexture_getPitch(handle)
	EndMethod
	
	Method regenerateMipMapLevels(mipmapData:Byte Ptr = Null)
		IrrVideo_ITexture_regenerateMipMapLevels(handle, mipmapData)
	EndMethod

	Method hasMipMaps:Int()
		Return IrrVideo_ITexture_hasMipMaps(handle)
	EndMethod
	
	Method getName:SNamedPath()
		Return SNamedPath.createFromHandle(IrrVideo_ITexture_getName(handle), True)
	EndMethod

	Method isRenderTarget:Int()
		Return IrrVideo_ITexture_isRenderTarget(handle)
	EndMethod
	
	Method hasAlpha:Int()
		Return IrrVideo_ITexture_hasAlpha(handle) 
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrVideo_ITexture_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrVideo_ITexture_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrVideo_ITexture_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType




