' ------------------------------------------------------------------------------------
' irr::video::SLight wrappers
'
' WARNING: do Not Release handles obtained via the get() methods
' ------------------------------------------------------------------------------------
Public

Type SLight Extends IrrBase Final

	Function create:SLight()
		Return createFromHandle(IrrVideo_SLight_new())
	EndFunction

	Function createFromHandle:SLight(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SLight=New SLight
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrVideo_SLight_del(handle)
	EndMethod
	
	Method getAmbientColor:SColorf()
		' do not delete
		Return SColorf.createFromHandle(IrrVideo_SLight_getAmbientColor(handle),False)
	EndMethod
	
	Method getDiffuseColor:SColorf()
		' do not delete
		Return SColorf.createFromHandle(IrrVideo_SLight_getDiffuseColor(handle),False)
	EndMethod
	
	Method getSpecularColor:SColorf()
		' do not delete
		Return SColorf.createFromHandle(IrrVideo_SLight_getSpecularColor(handle),False)
	EndMethod
	
	Method getPosition:Vector3df()
		Return Vector3df.createFromHandle(IrrVideo_SLight_getPosition(handle), False)
	EndMethod
	
	Method getDirection:Vector3df()
		Return Vector3df.createFromHandle(IrrVideo_SLight_getDirection(handle), False)
	EndMethod

	Method getCastShadows:Int()
		Return IrrVideo_SLight_getCastShadows(handle)
	EndMethod
	
	Method setCastShadows(bCastShadows:Int)
		IrrVideo_SLight_setCastShadows(handle,bCastShadows)
	EndMethod
	
	Method getRadius:Float()
		Return IrrVideo_SLight_getRadius(handle)
	EndMethod
	
	Method setRadius(newrad:Float)
		IrrVideo_SLight_setRadius(handle,newrad)
	EndMethod

	Method getType:Int() ' returns E_LIGHT_TYPE
		Return IrrVideo_SLight_getType(handle) 
	EndMethod
	
	Method setType(E_LIGHT_TYPE:Int)
		IrrVideo_SLight_setType(handle,E_LIGHT_TYPE)
	EndMethod

	Method getAttenuation:Vector3df()
		Return Vector3df.createFromHandle(IrrVideo_SLight_getAttenuation(handle), False)
	EndMethod
	
	Method getOuterCone:Float()
		Return IrrVideo_SLight_getOuterCone(handle)
	EndMethod
	
	Method setOuterCone(outerCone:Float)
		IrrVideo_SLight_setOuterCone(handle, outerCone)
	EndMethod
	
	Method getInnerCone:Float()
		Return IrrVideo_SLight_getInnerCone(handle)
	EndMethod
	
	Method setInnerCone(innerCone:Float)
		IrrVideo_SLight_setOuterCone(handle, innerCone)
	EndMethod
	
	Method getFalloff:Float()
		Return IrrVideo_SLight_getFalloff(handle)
	EndMethod
	
	Method setFalloff(fallOff:Float)
		IrrVideo_SLight_setFalloff(handle, fallOff)
	EndMethod
			
EndType
