' this is an example showing how to display Irrlicht in a panel on a MaxGUI form.  i have modified it a bit
' by adding an eventreceiver to the Irrlicht instance to show how MaxGUI and Irrlicht events can coexist.
' it is important to note that there still is probably some issues to work out, but for now this works.
'
' NOTE: press the 'w' key to toggle wireframe

SuperStrict 
Framework Irrlicht.B3D

Import BRL.Basic
Import MaxGUI.Win32MaxGUIEx
Import BRL.EventQueue

Local window:TGadget
Local panel:TGadget

Local windowWidth:Int = 440
Local windowHeight:Int = 380

window=CreateWindow("Irrlicht Win32 BlitzMax window example",100,100, ..
	windowWidth,windowHeight,Null,WINDOW_TITLEBAR | WINDOW_CLIENTCOORDS | WINDOW_HIDDEN)

' create window To put irrlicht in
Local hIrrlichtWindow:TGadget=CreatePanel(50,80,320,220,window,PANEL_ACTIVE|PANEL_BORDER)

' create ok button
Local Ok:TGadget=CreateButton("OK - Close",windowWidth - 160,windowHeight - 40,150,30,window)

' this is not in the original, but is here to show you can have a textbox and enter into it
' without the events posting to Irrlicht
Local tb:TGadget=CreateTextField(windowWidth - 160,windowHeight - 70,150,20,window)

' create some text
CreateLabel("This is Irrlicht running inside a Win32 MaxGUI window.",20,20,400,40,window)
	
Local param:SIrrlichtCreationParameters=SIrrlichtCreationParameters.Create()
param.setWindowId(QueryGadget(hIrrlichtWindow,QUERY_HWND))
param.setDriverType(EDT_OPENGL)

' create the device from the params object and initialize iB3D
ib3d_Graphics3DParams(param)

' setup a simple 3d scene

Local cam:CAMERA = ib3d_CreateCamera()
ib3d_MoveEntity(cam,0,20,-20)

Local cube:PRIMITIVE = ib3d_CreateCube()

ib3d_EntityTexture(cube,ib3d_LoadTexture:TEXTURE("../media/wall.bmp"),0,0)
ib3d_EntityTexture(cube,ib3d_LoadTexture:TEXTURE("../media/water.jpg"),0,1)
ib3d_EntityFX(cube,EMF_LIGHTING,False)
ib3d_EntityBlend(cube,EMT_REFLECTION_2_LAYER)

ib3d_PointEntity(cam,cube)

' show And execute dialog
ShowGadget(window)

' do message queue

Local bWireFrame:Int = False

While (True)

	ib3d_UpdateWorld()
	ib3d_RenderWorld()

	If PeekEvent() Then 
		PollEvent()
		Select EventID()
			Case EVENT_WINDOWCLOSE
				Exit
			Case EVENT_GADGETACTION
				If EventSource()=Ok
					PostEvent(CreateEvent(EVENT_WINDOWCLOSE,Ok))
				EndIf
			Default
				ActivateGadget(hIrrlichtWindow)
				If EventID()=EVENT_KEYDOWN And EventData()=KEY_W
					bWireFrame = Not bWireFrame
					ib3d_EntityFX(cube,EMF_WIREFRAME,bWireFrame)					
				EndIf
		End Select
	End If		
	
Wend

ib3d_EndGraphics()

